import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.beans.*;
import java.util.*;
import com.javawisdom.util.print.*;

public class ComponentTest  extends JFrame{
	
	JPanel mainPanel;
	
	JTabbedPane tabPane;
	
	JvPrinter jvprinter;

    ComponentPanel componentPanel;


	ButtonsAppPanel buttonsAppPanel;
	
	
		public ComponentTest()
	{
		super();
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setTitle("JvJvPrinter Test");
    	mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout(5, 5));

		tabPane = new JTabbedPane();
		jvprinter = new JvPrinter();
		
		componentPanel = new ComponentPanel(this);
		tabPane.addTab("Component", componentPanel);
		buttonsAppPanel = new ButtonsAppPanel(this);

		mainPanel.add(tabPane, BorderLayout.CENTER);
		mainPanel.add(buttonsAppPanel, BorderLayout.SOUTH);
	
		getContentPane().add(mainPanel, BorderLayout.CENTER);
	}
	public static void main(String args[])
	{

	ComponentTest testApp = new ComponentTest();
	testApp.setBounds(10,10,500,450);
		testApp.show();
	}
	
	
	}
	
class ComponentPanel extends JPanel implements ActionListener
{
	int INFO_COUNT = 3;

	JPanel upperPanel;
	JCheckBox ifToSingleCheckBox;

	JPanel lowerPanel;

	ComponentTest testApp;
	JPanel panel[];

	JLabel label1[];
	JLabel label2[];
	JLabel label3[];

	JTextField textField1[];
	JTextField textField2[];
	JTextField textField3[];


	public ComponentPanel(ComponentTest testApp)
	{
		this.testApp = testApp;

		setLayout(new BorderLayout(6, 5));

		upperPanel = new JPanel();
		upperPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
		ifToSingleCheckBox = new JCheckBox("Whether be printed to a single page or not", false);
		ifToSingleCheckBox.addActionListener(this);
		upperPanel.add(ifToSingleCheckBox);

		lowerPanel = new JPanel()
		{
			public Dimension getPreferredSize()
			{
				return new Dimension(400, INFO_COUNT * 160);
			}
		};
		lowerPanel.setLayout(new GridLayout(INFO_COUNT, 1, 20, 20));

		panel = new JPanel[INFO_COUNT];

		label1 = new JLabel[INFO_COUNT];
		label2 = new JLabel[INFO_COUNT];
		label3 = new JLabel[INFO_COUNT];


		textField1 = new JTextField[INFO_COUNT];
		textField2 = new JTextField[INFO_COUNT];
		textField3 = new JTextField[INFO_COUNT];


		for(int i = 0; i < INFO_COUNT; i++)
		{
			textField1[i] = new JTextField();
			textField2[i] = new JTextField();
			textField3[i] = new JTextField();

		}

		for(int i = 0; i < label1.length; i++)
			label1[i] = new JLabel("Sr No. : ");
		for(int i = 0; i < label2.length; i++)
			label2[i] = new JLabel("Name : ");
		for(int i = 0; i < label3.length; i++)
			label3[i] = new JLabel("Address : ");
	

		reset();

		JPanel leftPanel;
		JPanel rightPanel;

		for(int i = 0; i < panel.length; i++)
		{
			panel[i] = new JPanel();
			panel[i].setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), " Enter Information for Contact " + (i + 1) + " .", javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.TOP, new Font("Dialog", Font.BOLD, 12), Color.black));
			panel[i].setLayout(new BorderLayout(5, 5));

			leftPanel = new JPanel();
			leftPanel.setLayout(new GridLayout(5, 1, 10, 5));

			rightPanel = new JPanel();
			rightPanel.setLayout(new GridLayout(5, 1, 10, 5));

			leftPanel.add(label1[i]);	rightPanel.add(textField1[i]);
			leftPanel.add(label2[i]);	rightPanel.add(textField2[i]);
			leftPanel.add(label3[i]);	rightPanel.add(textField3[i]);
	
			panel[i].add(leftPanel, BorderLayout.WEST);
			panel[i].add(rightPanel, BorderLayout.CENTER);

			lowerPanel.add(panel[i]);
		}

		add(upperPanel, BorderLayout.NORTH);
		add(new JScrollPane(lowerPanel), BorderLayout.CENTER);
	}

	public Component getComponent()
	{
		return lowerPanel;
	}

	public Insets getInsets()
	{
		return new Insets(10, 20, 10, 20);
	}

	public void reset()
	{
		for(int i = 0; i < 3; i++)
		{
			textField1[i].setText("");
			textField2[i].setText("");
			textField3[i].setText("");
	}
	}

	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() == ifToSingleCheckBox)
		{
			testApp.jvprinter.setSinglePage(ifToSingleCheckBox.isSelected());
		}
	}
}
	
	
class ButtonsAppPanel extends JPanel implements ActionListener
{
	ComponentTest testApp;

	JButton pageSetupButton;
	JButton previewButton;
	JButton printButton;

	public ButtonsAppPanel(ComponentTest testApp)
	{
		this.testApp = testApp;
		setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));

		pageSetupButton = new JButton("Page Setup");
		pageSetupButton.addActionListener(this);

		previewButton = new JButton("Preview");
		previewButton.addActionListener(this);

		printButton = new JButton("Print");
		printButton.addActionListener(this);

		add(pageSetupButton);
		add(previewButton);
		add(printButton);
	}

	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() == pageSetupButton)
		{
			testApp.jvprinter.pageSetup(testApp);
		}
		else if(e.getSource() == previewButton)
		{
		testApp.jvprinter.setComponent(testApp.componentPanel.getComponent());
		
		testApp.jvprinter.preview(testApp);
		}
		else if(e.getSource() == printButton)
		{
		testApp.jvprinter.setComponent(testApp.componentPanel.getComponent());
		testApp.jvprinter.print();
		}
	}
}